/*
 * Iltasatu
 *
 * Original version by Niilo Paasivirta.
 * Augmented by Olli Kantola and Sami Kystil.
 *
 * Freely distributable for non-commercial use. 
 *
 */

#include <stdio.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define HENKILOF			"henkilo.wrd"
#define HENKADJF			"henkadj.wrd"
#define ASUINPAIKF		"asuinp.wrd"
#define ALKUF 				"alku.wrd"
#define ALKUJATKOF		"alkujtko.wrd"
#define MITENSAAPUIF	"miten.wrd"
#define KOHTASIPAF		"kohtasip.wrd"
#define MISTASAAPUIF	"mista.wrd"
#define MITENSITTENF	"mitensit.wrd"
#define MITASITTENF		"mitasit.wrd"

#define load(MISTA,MIHIN,LASKURI) f=fopen(MISTA,"r");\
																	LASKURI=0;\
																	while (!feof(f))\
																	{\
																		fgets(s,512,f);\
																		s[strlen(s)-1]='\0';\
																		MIHIN[LASKURI]=(char*)malloc(strlen(s)+1);\
																		if (!MIHIN[LASKURI]) break;\
																		strcpy(MIHIN[LASKURI++],s);\
																	}\
																	fclose(f);

#define unload(MIKA,LASKURI)	for (LASKURI--;LASKURI>=0;LASKURI--) free(MIKA[LASKURI]);

static char version_string[] = "\0$VER: satu 3.00 (28-Jul-99)";

int HENKILOM;
int HENKADJM;
int ASUINPAIKM;
int ALKUM;
int ALKUJATKOM;
int MITENSAAPUIM;
int KOHTASIPAM;
int MISTASAAPUIM;
int MITENSITTENM;
int MITASITTENM;

#define HENKILOMAX			512   
#define HENKADJMAX			512
#define ASUINPAIKMAX		512
#define ALKUMAX					512
#define ALKUJATKOMAX		512
#define MITENSAAPUIMAX	512
#define KOHTASIPAMAX		512
#define MISTASAAPUIMAX	512
#define MITENSITTENMAX	512
#define MITASITTENMAX		1024

char buf[4096];

char *henkilot[HENKILOMAX];
char *henkadj[HENKADJMAX];
char *asuinpaik[ASUINPAIKMAX];
char *alku[ALKUMAX];
char *alkujatko[ALKUJATKOMAX];
char *mitensaapui[MITENSAAPUIMAX];
char *kohtasipa[KOHTASIPAMAX];
char *mistasaapui[MISTASAAPUIMAX];
char *mitensitten[MITENSITTENMAX];
char *mitasitten[MITASITTENMAX];

int Rnd(int x)
{
  return ((rand() >> 8) % x);
}

/* Word wrap a string. Doesn't handle tabs, line feeds etc. */
static char outbuf[4096];

char * word_wrap(char *text, int width)
{
  char wbuf[256];
  char *p;
  char *o;
  int l,c,x;

  p = text;
  o = outbuf;
  l = 1;
  x = 0;

  while (*p && x < 3072)
    {
      c = 0;

      while ((*p) && (*p != ' ') && (c < width) && (c < 256))
	{
	  wbuf[c] = *p;
	  p++; c++;
	}

      wbuf[c] = 0;

      if (*p == ' ') p++;

      if (l > width)
	{
	  *o++ = '\n';
	  l = 1; x++;
	}

      strncpy(o,wbuf,c); o += strlen(wbuf);

      *o++ = ' ';

      x += (strlen(wbuf) + 1);
      l += (strlen(wbuf) + 1);
    }

  *o++ = '\n';
  *o++ = 0;

  return outbuf;
}

void main(int argc, char **argv)
{
  int henk1, henk2, hadj1, hadj2, a1;
  int lukumaaranlaskumuuttuja;
  long z;
  char adj1[80], adj2[80],s[1024];
	FILE *f;

	load(HENKILOF,				henkilot,				HENKILOM);
	load(HENKADJF,				henkadj,				HENKADJM);
	load(ASUINPAIKF,			asuinpaik,			ASUINPAIKM);
	load(ALKUF,						alku,						ALKUM);
	load(ALKUJATKOF,			alkujatko,			ALKUJATKOM);
	load(MITENSAAPUIF,		mitensaapui,		MITENSAAPUIM);
	load(KOHTASIPAF,			kohtasipa,			KOHTASIPAM);
	load(MISTASAAPUIF,		mistasaapui,		MISTASAAPUIM);
	load(MITENSITTENF,		mitensitten,		MITENSITTENM);
	load(MITASITTENF,			mitasitten,			MITASITTENM);

  srand(time(NULL));

  if (argc > 1)
      {
	if (!strcmp(argv[1], "-h") ||
	    !strcmp(argv[1], "-?"))
	  {
	    printf("Erilaisia satuja on (suunnilleen) nin monta:\n%Le\n",
	      (long double)
	      HENKILOM * (HENKILOM - 1) * HENKILOM * (HENKILOM - 1) *
	      HENKADJM * (HENKADJM - 1) * HENKADJM * (HENKADJM - 1) *
	      HENKADJM * (HENKADJM - 1) * HENKADJM * (HENKADJM - 1) *
	      ASUINPAIKM * ALKUM * ALKUJATKOM *
	      MITENSAAPUIM * (KOHTASIPAM / 2) * MISTASAAPUIM *
	      MITENSITTENM * MITASITTENM);
	    exit(0);
	  }
	lukumaaranlaskumuuttuja = atoi(argv[1]);
      }
  else
    lukumaaranlaskumuuttuja = 0;

  z = 0;

ohjelman_paasilmukka:

  henk1 = Rnd(HENKILOM);
  henk2 = Rnd(HENKILOM);

  hadj1 = Rnd(HENKADJM);
  hadj2 = Rnd(HENKADJM);

  while ((hadj1 == hadj2) && ((henk2 == henk1)))
    goto ohjelman_paasilmukka;

  (void)strcpy(adj1, henkadj[hadj1]);
  (void)strcpy(adj2, henkadj[hadj2]);

  while (Rnd(100) < 16)
    {
      do { a1 = Rnd(HENKADJM); } while (a1 == hadj1);
      (void)strcat(adj1, (Rnd(100) < 23 ? " mutta " : " "));
      (void)strcat(adj1, henkadj[a1]);
    }

  while (Rnd(100) < 16)
    {
      do { a1 = Rnd(HENKADJM); } while (a1 == hadj2);
      (void)strcat(adj2, (Rnd(100) < 23 ? " mutta " : " "));
      (void)strcat(adj2, henkadj[a1]);
    }

  z++;

if (Rnd(100) < 60)
  sprintf(buf,
"(%ld) Olipa kerran, %s %s %s %s, %s. Tm %s %s asui %s. %s %s %s%s. %s %s %s ja %s %s %s. Sen pituinen se.",
	  z,
	  alku[Rnd(ALKUM)],
	  (Rnd(10) > 5 ? "ers" : "muuan"),
	  adj1, henkilot[henk1],
	  alkujatko[Rnd(ALKUJATKOM)],
	  adj1, henkilot[henk1],
	  asuinpaik[Rnd(ASUINPAIKM)],
	  mitensaapui[Rnd(MITENSAAPUIM)],
	  adj2, henkilot[henk2],
	  mistasaapui[Rnd(MISTASAAPUIM)],
	  mitensitten[Rnd(MITENSITTENM)],
	  adj1, henkilot[henk1],
	  adj2, henkilot[henk2],
	  mitasitten[Rnd(MITASITTENM)]
	  );
else
  sprintf(buf,
"(%ld) Olipa kerran, %s %s %s %s joka liikkui%s, %s. "
"%s %s %s, joka asui %s. %s %s %s ja %s %s %s. "
"Sen pituinen se.",
	  z,
	  alku[Rnd(ALKUM)],
	  (Rnd(10) > 5 ? "ers" : "muuan"),
	  henkadj[hadj1], henkilot[henk1],
	  mistasaapui[Rnd(MITENSAAPUIM)],
	  alkujatko[Rnd(ALKUJATKOM)],

	  kohtasipa[Rnd(KOHTASIPAM)],
	  henkadj[hadj2], henkilot[henk2],
	  asuinpaik[Rnd(ASUINPAIKM)],

	  mitensitten[Rnd(MITENSITTENM)],
	  henkadj[hadj1], henkilot[henk1],
	  henkadj[hadj2], henkilot[henk2],
	  mitasitten[Rnd(MITASITTENM)]
	  );

  printf("%s", word_wrap(buf, 55));

  if (lukumaaranlaskumuuttuja && (--lukumaaranlaskumuuttuja > 0))
    {
      printf("\n");
      goto ohjelman_paasilmukka;
    }

	unload(henkilot,			HENKILOM);
	unload(henkadj,				HENKADJM);
	unload(asuinpaik,			ASUINPAIKM);
	unload(alku,					ALKUM);
	unload(alkujatko,			ALKUJATKOM);
	unload(mitensaapui,		MITENSAAPUIM);
	unload(kohtasipa,			KOHTASIPAM);
	unload(mistasaapui,		MISTASAAPUIM);
	unload(mitensitten,		MITENSITTENM);
	unload(mitasitten,		MITASITTENM);
}
